# -*- mode: python; mode: font-lock; py-indent-offset: 4; -*-
# $Id: buildenv.py,v 1.4 2004/08/19 19:17:25 mok Exp $
#
# Copyright (C) 2004 Morten Kjeldgaard <mok@bioxray.dk>
#
# This file is part of the program "repo-janitor".
#
# "repo-janitor" is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# "repo-janitor" is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with "repo-janitor" in a file named "COPYING".  If not, visit
# their website at http://www.gnu.org for a copy, or request a copy by
# writing to:
#     Free Software Foundation, Inc.
#     59 Temple Place, Suite 330
#     Boston, MA 02111-1307 USA


import os, commands
import message

topdir = "/tmp/repo-janitor"

# This class controls the building environment

class BuildEnv:
    m = message.Message()
    
    def __init__(self):
        self.dirs = []
        self.dirs.append(topdir)
        self.dirs.append(os.path.join(topdir,"SOURCES"))
        self.dirs.append(os.path.join(topdir,"SPECS"))
        self.dirs.append(os.path.join(topdir,"BUILD"))
        self.dirs.append(os.path.join(topdir,"tmp"))
    #;

    # create all dirs in build environment.
    def create (self):
        for d in self.dirs:
            if not os.path.exists(d):
                try:
                    os.mkdir(d)
                    self.m.info("created %s\n"%d)
                except OSError:
                    self.m.failure("could not mkdir %s\n"%d)
                    raise SystemExit
                #;
            #;
        #;
    #;

    # Get rid of dirs again...
    def destroy(self):
        self.m.warning("removing build environment in %s\n"%topdir)
        err, outp = commands.getstatusoutput("/bin/rm -rf "+topdir)
        if err != 0:
            self.m.failure("could not remove %s\n"%topdir)
        #;
    #;
#;


        
if __name__ == "__main__":
    be = BuildEnv()
    be.create()
    be.destroy()
