# -*- mode: python; mode: font-lock; py-indent-offset: 4; -*-
# $Id: stack.py,v 1.2 2004/10/21 09:49:05 mok Exp $

import string

# List-based implementation of a stack class.
class Stack:
    def __init__(self):
        self.stack = []

    def push(self, object):
        self.stack.append(object)

    def pop(self):
        if len(self.stack) == 0:
            raise "Error", "empty stack"
        #;
        obj = self.stack[-1]
        del self.stack[-1]
        return obj

    def top (self):
        if self.stack:
            return self.stack[-1]
        else:
            raise "Error", "empty stack"
        #;
    #;
    
    def isempty(self):
        if len(self.stack) == 0:
            return 1
        #;
        return 0
    #;

    def __repr__(self):
        return "<Stack %s>" % str(self.stack)
    #;

    def __str__(self):
        return repr(self.stack)
    #;
#;

if __name__ == "__main__":
    import time

    pushes = 100000
    pops = pushes
    s = Stack()                              # Stack
    push = s.push
    pop = s.pop

    start_cpu  = time.clock()
    for i in range(pushes): push('spam'+'i')
    for i in range(pops):   top = pop()
    t=time.clock()-start_cpu
    print 'Stack (with %d pushes + %d pops): %f' % (pushes,pops,t)
###
